package net.vision_design.loginapp;

import android.Manifest;
import android.app.IntentService;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.ResultReceiver;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.AbsListView;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import static android.view.View.generateViewId;

/**
 * Created by Owner on 2/13/2017.
 */

public class CheckNewVersionActivity extends AppCompatActivity {

    String version;
    LinearLayout parent;
    TextView name;
    Button b_ok, b_update;

    private Intent uService = null;

    final int ok_id = generateViewId();
    final int update_id = generateViewId();

    XelfResultReceiver resultReceiever;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        resultReceiever = new XelfResultReceiver(new Handler());
      //  parent = new LinearLayout(this);
       // parent.setOrientation(LinearLayout.VERTICAL);

        getVersion();
    }

    public void getVersion(){
        class GetData extends AsyncTask<String, Void, String> {

            @Override
            protected String doInBackground(String... params) {
                String result = null;
                try {
                    URL url = new URL("http://xelf.ca/registration/version.php");
                    JSONObject postDataParams = new JSONObject();

                    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                    conn.setReadTimeout(25000);
                    conn.setConnectTimeout(25000);
                    conn.setRequestMethod("POST");
                    conn.setDoInput(true);
                    conn.setDoOutput(true);

                    OutputStream os = conn.getOutputStream();
                    BufferedWriter writer = new BufferedWriter(
                            new OutputStreamWriter(os, "UTF-8"));
                    writer.write(getPostDataString(postDataParams));

                    writer.flush();
                    writer.close();
                    os.close();

                    int responseCode=conn.getResponseCode();

                    if (responseCode == HttpURLConnection.HTTP_OK) {

                        BufferedReader in=new BufferedReader(
                                new InputStreamReader(
                                        conn.getInputStream()));
                        StringBuffer sb = new StringBuffer("");
                        String line="";

                        while((line = in.readLine()) != null) {

                            sb.append(line);
                            break;
                        }

                        in.close();
                        result = sb.toString();

                    }
                    else {
                        //return new String("false : "+responseCode);
                    }
                } catch(Exception e){
                    //return new String("Exception: " + e.getMessage());
                }
                return result;
            }

            @Override
            protected void onPostExecute(String result){
                version=result;
                showXML();
            }

            public String getPostDataString(JSONObject params) throws Exception {

                StringBuilder result = new StringBuilder();
                boolean first = true;

                Iterator<String> itr = params.keys();

                while(itr.hasNext()){

                    String key= itr.next();
                    Object value = params.get(key);

                    if (first)
                        first = false;
                    else
                        result.append("&");

                    result.append(URLEncoder.encode(key, "UTF-8"));
                    result.append("=");
                    result.append(URLEncoder.encode(value.toString(), "UTF-8"));

                }
                return result.toString();
            }
        }
        GetData g = new GetData();
        g.execute();
    }

    public static int getVersionCode(Context context) {
        PackageManager pm = context.getPackageManager();
        try {
            PackageInfo pi = pm.getPackageInfo(context.getPackageName(), 0);
            return pi.versionCode;
        } catch (PackageManager.NameNotFoundException ex) {}
        return 0;
    }

    public void showXML(){
        int c_version = CheckNewVersionActivity.getVersionCode(this);
        int new_version = Integer.parseInt(version);

        parent = new LinearLayout(this);
        parent.setOrientation(LinearLayout.VERTICAL);

        //LayoutParams param = new LayoutParams(LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.MATCH_PARENT);
        LayoutParams param = new LayoutParams(LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        param.setMargins(0, 100, 0, 0);
        if (new_version > c_version) {
            name = new TextView(this);
            //name.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT));
            name.setLayoutParams(param);
            name.setText("There is a new version of Xelf_app. If you click the Update button, the process will run in the background ");
            name.setGravity(Gravity.CENTER_HORIZONTAL);
            parent.addView(name);

            b_update = new Button(this);
            //b_ok.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT));
            b_update.setLayoutParams(param);
            b_update.setText(" Update ");
            b_update.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (Build.VERSION.SDK_INT >= 23) {
                        if (ContextCompat.checkSelfPermission(CheckNewVersionActivity.this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED) {
                        }
                        else {
                            ActivityCompat.requestPermissions(CheckNewVersionActivity.this, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
                        }
                    }
                    uService = new Intent(CheckNewVersionActivity.this, UpdateService.class);
                    uService.putExtra("receiver", resultReceiever);
                    startService(uService);
                    finish();
                }
            });
            parent.addView(b_update);
        }else{
            name = new TextView(this);
            //name.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT));
            name.setLayoutParams(param);
            name.setText("There is no new version for Xelf app. The current version is updated.");
            name.setGravity(Gravity.CENTER_HORIZONTAL);
            parent.addView(name);

            b_ok = new Button(this);
            //b_ok.setLayoutParams(new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT));
            b_ok.setLayoutParams(param);
            b_ok.setText("   OK   ");
            b_ok.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    finish();
                }
            });
            parent.addView(b_ok);
        }
        setContentView(parent);
    } // end of showXML method

    private class XelfResultReceiver extends ResultReceiver {

        public XelfResultReceiver(Handler handler) {
            super(handler);
        }

        @Override
        protected void onReceiveResult(int resultCode, Bundle resultData) {
            switch (resultCode) {
                case UpdateService.DOWNLOAD_ERROR:
                    Toast.makeText(getApplicationContext(), "Error in download app file",
                            Toast.LENGTH_SHORT).show();
                    break;

                case UpdateService.DOWNLOAD_SUCCESS:

                    //Toast.makeText(getApplicationContext(), "Xelf app update successful",
                     //       Toast.LENGTH_SHORT).show();
                    break;
            }
            super.onReceiveResult(resultCode, resultData);
        }

    }


}
