package net.vision_design.loginapp;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

/**
 * Created by Owner on 2/16/2017.
 */

public class CommentListAdapter extends BaseAdapter {
    private Context mContext;

    private LayoutInflater mLayoutInflater;

    private ArrayList<Comments> mComment;

    //private final ImageDownloader mImageDownloader;

    public CommentListAdapter(Context context, ArrayList<Comments> commentList) {
        mContext = context;
        mComment = commentList;
        mLayoutInflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    }

    @Override
    public int getCount() {
        return mComment.size();
    }

    @Override
    public Object getItem(int position) {
        return mComment.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        View itemView =  mLayoutInflater.inflate(R.layout.comment_item, parent, false);
        if (convertView == null) {
            TextView commentText = (TextView) itemView.findViewById(R.id.comment_content);
            TextView dateText = (TextView) itemView.findViewById(R.id.comment_date);
            Comments comments = (Comments) getItem(position);
            commentText.setText(comments.comment_content);

            dateText.setText(comments.comment_date);
        } else {
            itemView = convertView;
        }

        return itemView;
    }

}
