package net.vision_design.loginapp;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;

import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;

import android.widget.Toast;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

public class MainActivity extends AppCompatActivity {
    //public static final String MyPREFERENCES = "MyPrefs" ;
    //public static final String USERID = "idKey";
    String email;
    String password;
    String urlParameters;
    //SharedPreferences sharedpreferences;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        String uid = SaveSharedPreference.getUserId(MainActivity.this);
        if(uid.length() == 0)
        {
            setContentView(R.layout.activity_main);  // call Login Activity
        }
        else
        {
            if (Integer.parseInt(uid) > 1) { // to user
                Intent intent = new Intent(this, UserTabActivity.class);
                startActivity(intent);
            }else{  // to admin
                Intent intent = new Intent(this, TabledUserActivity.class);
                startActivity(intent);
            }
        }

        setContentView(R.layout.activity_main);

    }

    public void registerClicked (View view) throws Exception {
        Intent intent = new Intent(this, RegisterActivity.class);
        startActivity(intent);
    }

    public void loginClicked(View view) throws Exception {
        // Do something in response to button
       // sharedpreferences = getSharedPreferences(MyPREFERENCES, Context.MODE_PRIVATE);
        EditText editText = (EditText) findViewById(R.id.emailField);
        email = editText.getText().toString();
        EditText passwordText = (EditText) findViewById(R.id.passwordField);
        password = passwordText.getText().toString();
        String url = "http://xelf.ca/registration/login.php";

        SendPostRequest sendPostRequest = new SendPostRequest();
        String r = sendPostRequest.execute(url, email, password).get();

        String parts[] = r.split("---");
        r = parts[0];
/*        Toast t = Toast.makeText(getApplicationContext(), r,
                Toast.LENGTH_LONG);
        t.setGravity(Gravity.CENTER, 0, -500);
        t.show();
        //exit(0);*/
        if (r.equals("admin")){
           // Intent intent = new Intent(this, ViewUserActivity.class);
            SaveSharedPreference.setUserId(MainActivity.this, String.valueOf(1));
            Intent intent = new Intent(this, TabledUserActivity.class);
            startActivity(intent);
        }else if (r.equals("user")){
            int id = Integer.parseInt(parts[1]);

            //final GlobalUserid globalUserid = (GlobalUserid) getApplicationContext();
            //globalUserid.setUserid(id);
            SaveSharedPreference.setUserId(MainActivity.this, String.valueOf(id));

            Intent intent = new Intent(this, UserTabActivity.class);
            startActivity(intent);
        }else {
            Toast toast = Toast.makeText(getApplicationContext(), "Login failed. Please try again",
                    Toast.LENGTH_LONG);
            toast.setGravity(Gravity.CENTER, 0, -500);
            toast.show();
        }

    }

    //send post method which will be called from loginClicked method
//    private String sendPost(String url, String urlParameters) throws Exception {
    public class SendPostRequest extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("email", params[1]);
                postDataParams.put("password", params[2]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }
}
