package net.vision_design.loginapp;

import android.Manifest;
import android.app.ProgressDialog;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Environment;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

public class NewsActivity extends AppCompatActivity {
    String newsJSON;
    private ProgressDialog pDialog;

    private static final String TAG_RESULTS="result";

    JSONArray jArray = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_news);

        getData();
    }

    public void getData(){
        class GetDataJSON extends AsyncTask<String, Void, String> {

            @Override
            protected String doInBackground(String... params) {
                String result = null;
                try {
                    URL url = new URL("http://xelf.ca/registration/getNews.php");
                    JSONObject postDataParams = new JSONObject();

                    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                    conn.setReadTimeout(25000);
                    conn.setConnectTimeout(25000);
                    conn.setRequestMethod("POST");
                    conn.setDoInput(true);
                    conn.setDoOutput(true);

                    OutputStream os = conn.getOutputStream();
                    BufferedWriter writer = new BufferedWriter(
                            new OutputStreamWriter(os, "UTF-8"));
                    writer.write(getPostDataString(postDataParams));

                    writer.flush();
                    writer.close();
                    os.close();

                    int responseCode=conn.getResponseCode();

                    if (responseCode == HttpURLConnection.HTTP_OK) {

                        BufferedReader in=new BufferedReader(
                                new InputStreamReader(
                                        conn.getInputStream()));
                        StringBuffer sb = new StringBuffer("");
                        String line="";

                        while((line = in.readLine()) != null) {

                            sb.append(line);
                            break;
                        }

                        in.close();
                        result = sb.toString();

                    }
                    else {
                        //return new String("false : "+responseCode);
                    }
                } catch(Exception e){
                    //return new String("Exception: " + e.getMessage());
                }
                return result;
            }

            @Override
            protected void onPostExecute(String result){
                newsJSON=result;
                showList();
            }

            public String getPostDataString(JSONObject params) throws Exception {

                StringBuilder result = new StringBuilder();
                boolean first = true;

                Iterator<String> itr = params.keys();

                while(itr.hasNext()){

                    String key= itr.next();
                    Object value = params.get(key);

                    if (first)
                        first = false;
                    else
                        result.append("&");

                    result.append(URLEncoder.encode(key, "UTF-8"));
                    result.append("=");
                    result.append(URLEncoder.encode(value.toString(), "UTF-8"));

                }
                return result.toString();
            }
        }
        GetDataJSON g = new GetDataJSON();
        g.execute();
    }

    protected void showList(){
        try {
            JSONObject jsonObj = new JSONObject(newsJSON);
            jArray = jsonObj.getJSONArray(TAG_RESULTS);

            //TableLayout tv = (TableLayout) getActivity().findViewById(R.id.tableNews);
            TableLayout tv = (TableLayout) findViewById(R.id.news_table);
            //tv.removeAllViewsInLayout();
            int flag = 1;
            for (int i = -1; i < jArray.length(); i++) {
                TableRow tr = new TableRow(this);
                tr.setLayoutParams(new TableLayout.LayoutParams(
                        TableLayout.LayoutParams.MATCH_PARENT,
                        TableRow.LayoutParams.WRAP_CONTENT));
                Log.i("log_tag", Integer.toString(i));
                if (flag == 1) {
                    TextView b6 = new TextView(this);
                    b6.setPadding(10, 0, 30, 0);
                    b6.setText("Title");
                    b6.setTextColor(Color.BLUE);
                    b6.setTextSize(15);
                    tr.addView(b6);
                    TextView b19 = new TextView(this);
                    b19.setPadding(10, 0, 0, 0);
                    b19.setTextSize(15);
                    b19.setText("Action");
                    b19.setTextColor(Color.BLUE);
                    tr.addView(b19);

                    tv.addView(tr);
                    final View vline = new View(this);
                    vline.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, 2));
                    vline.setBackgroundColor(Color.BLUE);
                    tv.addView(vline);
                    flag = 0;
                } else {
                    JSONObject json_data = jArray.getJSONObject(i);
                    //Log.i("log_tag", "id: " + json_data.getInt("id") + ", Username: " + json_data.getString("name") + ", No: " + json_data.getString("email"));
                    //  TextView b = new TextView(getActivity());
                    String path = json_data.getString("n_path");
                  /*  b.setText(stime);
                    b.setTextColor(Color.RED);
                    b.setTextSize(15);
                    tr.addView(b);*/
                    TextView b1 = new TextView(this);
                    b1.setPadding(10, 5, 20, 5);
                    b1.setTextSize(15);
                    String stime1 = json_data.getString("title");
                    b1.setText(stime1);
                    b1.setTextColor(Color.BLACK);
                    tr.addView(b1);

                    Button btn1 = new Button(this);
                    btn1.setPadding(10, 0, 20, 0);
                    btn1.setText("View PDF");
                    btn1.setTag(path);
                    //btn1.setOnClickListener( TabledUserActivity.this );
                    btn1.setOnClickListener(btnClick);
                    btn1.setTextColor(Color.BLACK);
                    btn1.setTextSize(15);
                    tr.addView(btn1);

                    tv.addView(tr);
                    final View vline1 = new View(this);
                    vline1.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, 1));
                    vline1.setBackgroundColor(Color.WHITE);
                    tv.addView(vline1);
                }
            }
        } catch (JSONException e) {
            Log.e("log_tag", "Error parsing data" + e.toString());
            Toast.makeText(this, "JsonArray fail", Toast.LENGTH_SHORT).show();
        }

    }

    private View.OnClickListener btnClick = new View.OnClickListener(){
        public void onClick(View v) {
            String news_file_name = v.getTag().toString();
          /*  Bundle args = new Bundle();
            args.putString("news_id", nid);

            FragmentTransaction fragmentTransaction = getActivity().getSupportFragmentManager().beginTransaction();

            Fragment viewNews = new ViewNews();
            viewNews.setArguments(args);

            fragmentTransaction.replace(R.id.viewpager, viewNews);
            fragmentTransaction.addToBackStack(null);
            fragmentTransaction.commit();*/
          /*  Intent intent = new Intent(getActivity(), ViewNewsActivity.class);
            intent.putExtra("news_id",nid);
            startActivity(intent);*/
            new NewsActivity.DownloadFile().execute("http://xelf.ca/registration/news_folder/" + news_file_name, news_file_name);
            File pdfFile = null;
            if (Build.VERSION.SDK_INT >= 23) {
                if (ContextCompat.checkSelfPermission(NewsActivity.this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED) {
                }
                else {
                    ActivityCompat.requestPermissions(NewsActivity.this, new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
                }
            }
            pdfFile = new File(Environment.getExternalStorageDirectory() + "/PDF DOWNLOAD/" + news_file_name);

            if (pdfFile.exists()) {
                Uri path = Uri.fromFile(pdfFile);
                Intent pdfIntent = new Intent(Intent.ACTION_VIEW);
                pdfIntent.setDataAndType(path, "application/pdf");
                pdfIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);

                Intent intent = Intent.createChooser(pdfIntent, "Open File");

                try {
                    startActivity(intent);
                    //startActivity(pdfIntent);
                } catch (ActivityNotFoundException e) {
                    Toast.makeText(NewsActivity.this, "No Application available to view PDF", Toast.LENGTH_SHORT).show();
                }
            }else {
                Toast.makeText(NewsActivity.this, "The file not exists! ", Toast.LENGTH_SHORT).show();
            }
        }
    };

    private class DownloadFile extends AsyncTask<String, Void, Void>{

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            //showpDialog();
        }

        @Override
        protected Void doInBackground(String... strings) {

            String fileUrl = strings[0];
// -> https://letuscsolutions.files.wordpress.com/2015/07/five-point-someone-chetan-bhagat_ebook.pdf
            String fileName = strings[1];
// ->five-point-someone-chetan-bhagat_ebook.pdf
            String extStorageDirectory = Environment.getExternalStorageDirectory().toString();
            File folder = new File(extStorageDirectory, "PDF DOWNLOAD");
            folder.mkdir();

            File pdfFile = new File(folder, fileName);

            try{
                pdfFile.createNewFile();
            }catch (IOException e){
                e.printStackTrace();
            }
            FileDownloader.downloadFile(fileUrl, pdfFile);
            return null;

        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);
            //hidepDialog();
            // Toast.makeText(getActivity(), "Download PDf successfully", Toast.LENGTH_SHORT).show();

            // Log.d("Download complete", "----------");
        }
    }

}
