package net.vision_design.loginapp;

import android.content.Intent;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;

import javax.net.ssl.HttpsURLConnection;

public class RegisterActivity extends AppCompatActivity {
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_register);
    }

    public void registerAccount(View view) throws Exception {
        // Do something in response to button
        EditText fn = (EditText) findViewById(R.id.first_name);
        String firstname = fn.getText().toString();
        EditText ln = (EditText) findViewById(R.id.last_name);
        String lastname = ln.getText().toString();
        EditText eml = (EditText) findViewById(R.id.email);
        String email = eml.getText().toString();
        EditText passwordText = (EditText) findViewById(R.id.password);
        String password = passwordText.getText().toString();
        String url = "http://xelf.ca/registration/registration.php";

        PostRegistration postRegistration = new PostRegistration();
        String r = postRegistration.execute(url, firstname, lastname, email, password).get();

        Toast t = Toast.makeText(getApplicationContext(), r,
                Toast.LENGTH_LONG);
        t.setGravity(Gravity.CENTER, 0, -500);
        t.show();
    }

    public void continueClicked(View view) throws Exception {
        // Do something in response to button
        Intent intent = new Intent(this, MainActivity.class);
        startActivity(intent);
    }

    //send post method which will be called from loginClicked method
//    private String sendPost(String url, String urlParameters) throws Exception {
    public class PostRegistration extends AsyncTask<String, Void, String> {

        protected void onPreExecute(){}
        @Override
        protected String doInBackground(String... params) {
            try{
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("firstname", params[1]);
                postDataParams.put("lastname", params[2]);
                postDataParams.put("email", params[3]);
                postDataParams.put("password", params[4]);
                Log.e("params",postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode=conn.getResponseCode();
             //   return params[1];
                if (responseCode == HttpsURLConnection.HTTP_OK) {

                    BufferedReader in=new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line="";

                    while((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                }
                else {
                    return new String("false : "+responseCode);
                }
            }
            catch(Exception e){
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {
            Toast toast = Toast.makeText(getApplicationContext(), result,
                    Toast.LENGTH_LONG);
            toast.setGravity(Gravity.CENTER, 0, -500);
            toast.show();
        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while(itr.hasNext()){

                String key= itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }
}
