package net.vision_design.loginapp;

import android.content.Intent;
import android.graphics.Color;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Html;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;
import android.widget.HorizontalScrollView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.SimpleAdapter;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import android.util.Log;
import android.view.View;
import android.widget.Toast;
import android.widget.TableRow.LayoutParams;

import static java.lang.Integer.valueOf;
import static net.vision_design.loginapp.R.id.tableView;

public class TabledUserActivity extends AppCompatActivity {
    String userJSON;

    private static final String TAG_RESULTS="result";

    JSONArray jArray = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tabled_user);

        getData();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.admin_menu, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        if (id == R.id.logout_item) {
           // final GlobalUserid globalUserid = (GlobalUserid) getApplicationContext();
           // globalUserid.setUserid(0);
            SaveSharedPreference.setUserId(TabledUserActivity.this, "");

            Intent intent = new Intent(this, MainActivity.class);
            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivity(intent);

         //   intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
          //  intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);

            finish();
            return true;
        }else if (id == R.id.user_list){
            Intent intent = new Intent(this, TabledUserActivity.class);
            startActivity(intent);
            return true;
        }else if (id == R.id.admin_news){
            Intent intent = new Intent(this, AdminNewsActivity.class);
            startActivity(intent);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    protected void showList(){
        try {
            JSONObject jsonObj = new JSONObject(userJSON);
            jArray = jsonObj.getJSONArray(TAG_RESULTS);

            TableLayout tv = (TableLayout) findViewById(tableView);
            //tv.removeAllViewsInLayout();
            int flag = 1;
            for (int i = -1; i < jArray.length(); i++) {
                TableRow tr = new TableRow(TabledUserActivity.this);
                tr.setLayoutParams(new TableLayout.LayoutParams(
                        TableLayout.LayoutParams.MATCH_PARENT,
                        LayoutParams.WRAP_CONTENT));
                Log.i("log_tag", Integer.toString(i));
                if (flag == 1) {
                    TextView b6 = new TextView(TabledUserActivity.this);
                    b6.setPadding(10, 0, 30, 0);
                    b6.setText("Id");
                    b6.setTextColor(Color.BLUE);
                    b6.setTextSize(15);
                    tr.addView(b6);
                    TextView b19 = new TextView(TabledUserActivity.this);
                    b19.setPadding(10, 0, 0, 0);
                    b19.setTextSize(15);
                    b19.setText("Name");
                    b19.setTextColor(Color.BLUE);
                    tr.addView(b19);
                    TextView b11 = new TextView(TabledUserActivity.this);
                    b11.setPadding(10, 0, 0, 0);
                    b11.setTextSize(15);
                    b11.setText("Email");
                    b11.setTextColor(Color.BLUE);
                    tr.addView(b11);
                    TextView b29 = new TextView(TabledUserActivity.this);
                    b29.setPadding(10, 0, 0, 0);
                    b29.setText("Status");
                    b29.setTextColor(Color.BLUE);
                    b29.setTextSize(15);
                    tr.addView(b29);

                    TextView b27 = new TextView(TabledUserActivity.this);
                    b27.setPadding(30, 0, 0, 0);
                    b27.setText("Action");
                    b27.setTextColor(Color.BLUE);
                    b27.setTextSize(15);
                    tr.addView(b27);

                    tv.addView(tr);
                    final View vline = new View(TabledUserActivity.this);
                    vline.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.MATCH_PARENT, 2));
                    vline.setBackgroundColor(Color.BLUE);
                    tv.addView(vline);
                    flag = 0;
                } else {
                    JSONObject json_data = jArray.getJSONObject(i);
                    Log.i("log_tag", "id: " + json_data.getInt("id") + ", Username: " + json_data.getString("name") + ", No: " + json_data.getString("email"));
                    TextView b = new TextView(TabledUserActivity.this);
                    String stime = String.valueOf(json_data.getInt("id"));
                    b.setText(stime);
                    b.setTextColor(Color.RED);
                    b.setTextSize(15);
                    tr.addView(b);
                    TextView b1 = new TextView(TabledUserActivity.this);
                    b1.setPadding(10, 5, 20, 5);
                    b1.setTextSize(15);
                    String stime1 = json_data.getString("name");
                    b1.setText(stime1);
                    b1.setTextColor(Color.BLACK);
                    tr.addView(b1);
                    TextView b2 = new TextView(TabledUserActivity.this);
                    b2.setPadding(10, 0, 20, 0);
                    String stime2 = json_data.getString("email");
                    b2.setText(stime2);
                    b2.setTextColor(Color.BLACK);
                    b2.setTextSize(15);
                    tr.addView(b2);
                    TextView b20 = new TextView(TabledUserActivity.this);
                    b20.setPadding(10, 0, 20, 0);
                    String stime3 = json_data.getString("status");
                    String status = "Active";
                    if (stime3.equals("0")){ status = "Inactive"; }
                    b20.setText(status);
                    //b20.setText(stime3);
                    b20.setTextColor(Color.BLACK);
                    b20.setTextSize(15);
                    tr.addView(b20);

                    Button btn1 = new Button(TabledUserActivity.this);
                    btn1.setPadding(10, 0, 20, 0);
                    btn1.setText("Edit");
                    btn1.setTag(stime);
                    //btn1.setOnClickListener( TabledUserActivity.this );
                    btn1.setOnClickListener(btnClick);
                    btn1.setTextColor(Color.BLACK);
                    btn1.setTextSize(15);
                    tr.addView(btn1);

                    tv.addView(tr);
                    final View vline1 = new View(TabledUserActivity.this);
                    vline1.setLayoutParams(new TableRow.LayoutParams(LayoutParams.MATCH_PARENT, 1));
                    vline1.setBackgroundColor(Color.WHITE);
                    tv.addView(vline1);
                }
            }
        } catch (JSONException e) {
            Log.e("log_tag", "Error parsing data" + e.toString());
            Toast.makeText(getApplicationContext(), "JsonArray fail", Toast.LENGTH_SHORT).show();
        }

    }

    public void getData(){
        class GetDataJSON extends AsyncTask<String, Void, String> {

            @Override
            protected String doInBackground(String... params) {
                String result = null;
                try {
                    URL url = new URL("http://xelf.ca/registration/getAllUser.php");
                    JSONObject postDataParams = new JSONObject();

                    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                    conn.setReadTimeout(25000);
                    conn.setConnectTimeout(25000);
                    conn.setRequestMethod("POST");
                    conn.setDoInput(true);
                    conn.setDoOutput(true);

                    OutputStream os = conn.getOutputStream();
                    BufferedWriter writer = new BufferedWriter(
                            new OutputStreamWriter(os, "UTF-8"));
                    writer.write(getPostDataString(postDataParams));

                    writer.flush();
                    writer.close();
                    os.close();

                    int responseCode=conn.getResponseCode();

                    if (responseCode == HttpURLConnection.HTTP_OK) {

                        BufferedReader in=new BufferedReader(
                                new InputStreamReader(
                                        conn.getInputStream()));
                        StringBuffer sb = new StringBuffer("");
                        String line="";

                        while((line = in.readLine()) != null) {

                            sb.append(line);
                            break;
                        }

                        in.close();
                        result = sb.toString();

                    }
                    else {
                        //return new String("false : "+responseCode);
                    }
                } catch(Exception e){
                    //return new String("Exception: " + e.getMessage());
                }
                return result;
            }

            @Override
            protected void onPostExecute(String result){
                userJSON=result;
                showList();
            }

            public String getPostDataString(JSONObject params) throws Exception {

                StringBuilder result = new StringBuilder();
                boolean first = true;

                Iterator<String> itr = params.keys();

                while(itr.hasNext()){

                    String key= itr.next();
                    Object value = params.get(key);

                    if (first)
                        first = false;
                    else
                        result.append("&");

                    result.append(URLEncoder.encode(key, "UTF-8"));
                    result.append("=");
                    result.append(URLEncoder.encode(value.toString(), "UTF-8"));

                }
                return result.toString();
            }
        }
        GetDataJSON g = new GetDataJSON();
        g.execute();
    }

    private View.OnClickListener btnClick = new View.OnClickListener(){
        public void onClick(View v) {
            String bid = v.getTag().toString();

            int id = Integer.parseInt(bid);
            Intent intent = new Intent(getApplicationContext(), AdminUpdateProfileActivity.class);
            intent.putExtra("userid", id);
            startActivity(intent);
            //Toast.makeText(getApplicationContext(), bid, Toast.LENGTH_SHORT).show();
        }
    };
}
