package net.vision_design.loginapp;

import android.content.Intent;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.view.ViewPager;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;


public class UserTabActivity extends AppCompatActivity /*implements TabLayout.OnTabSelectedListener*/ {

    private Toolbar toolbar;
    private TabLayout tabLayout;
    private ViewPager viewPager;
    private String[] FRAGMENT_NAME = {"Set Goal", "Record", "Share", "Summary", "Profile"};
    MyPagerAdapter adapter;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.user_menu, menu);
        return true;
    }

    @Override
    //logout menu item clicked
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();

        if (id == R.id.logout_item) {
            //final GlobalUserid globalUserid = (GlobalUserid) getApplicationContext();
            //globalUserid.setUserid(0);
            SaveSharedPreference.setUserId(UserTabActivity.this, "");

            Intent intent = new Intent(this, MainActivity.class);
            intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivity(intent);

            //   intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            //  intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK);

            finish();
            return true;
        }else if(id == R.id.profile_item){
            Intent intent = new Intent(this, UserProfileActivity.class);
            startActivity(intent);
        }else if(id == R.id.check_new_version){
            Intent intent = new Intent(this, CheckNewVersionActivity.class);
            startActivity(intent);
        }else if(id == R.id.news_item){
            Intent intent = new Intent(this, NewsActivity.class);
            startActivity(intent);
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_tab);
        // Setting up Toolbar
        toolbar = (Toolbar) findViewById(R.id.toolbar);
       // toolbar.setTitle(FRAGMENT_NAME[0]);
        toolbar.setTitle("Xelf");
        setSupportActionBar(toolbar);

        //Initialize ViewPager
        viewPager = (ViewPager) findViewById(R.id.viewpager);
       // viewPager.setOffscreenPageLimit(6);
        //Setup ViewPager Adapter
        setupViewPager(viewPager);
        //Tablayout initialization
        tabLayout = (TabLayout) findViewById(R.id.tabs);

        tabLayout.setupWithViewPager(viewPager);
        tabLayout.setTabMode(TabLayout.MODE_SCROLLABLE);
        //setup Listeners to Tabs
        tabLayout. addOnTabSelectedListener(onTabSelectedListener(viewPager));

    }

    // This method will call Adapter for ViewPager
    private void setupViewPager(ViewPager viewPager) {
        adapter = new MyPagerAdapter(getSupportFragmentManager());

        adapter.addFragment(new SecondFragment(), FRAGMENT_NAME[0]);
        adapter.addFragment(new ThirdFragment(), FRAGMENT_NAME[1]);
       // adapter.addFragment(new FourthFragment(), FRAGMENT_NAME[2]);
        adapter.addFragment(new ShareFragment(), FRAGMENT_NAME[2]);
        adapter.addFragment(new FourthFragment(), FRAGMENT_NAME[3]);

        viewPager.setAdapter(adapter);
        viewPager.setOffscreenPageLimit(1);
        viewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(tabLayout));
        onTabSelectedListener(viewPager);
        //tabLayout.addOnTabSelectedListener(onTabSelectedListener(viewPager));
    }

/*    // These are the methods which handles Tab Selection, Unselection & Reselection
    @Override
    public void onTabSelected(TabLayout.Tab tab) {
        //Set the tab icon from selected array
        //  tab.setIcon(SELECTED_ICON[tab.getPosition()]);
       // toolbar.setTitle(FRAGMENT_NAME[tab.getPosition()]);
        //When Tab is clicked this line set the viewpager to corresponding fragment

        viewPager.setCurrentItem(tab.getPosition());
    }

    @Override
    public void onTabUnselected(TabLayout.Tab tab) {
        // Set icon from unselected tab array
        // tab.setIcon(UNSELECTED_ICON[tab.getPosition()]);

    }

    @Override
    public void onTabReselected(TabLayout.Tab tab) {
        //  tab.setIcon(SELECTED_ICON[tab.getPosition()]);
    }
*/
    private TabLayout.OnTabSelectedListener onTabSelectedListener(final ViewPager viewPager) {

        return new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                viewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {

            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        };
    }

}